datatype parity = Even of int | Odd of int

fun make_num n =
  case (n mod 2) of
      0 => Even n
    | _ => Odd n

fun mult m n =
  case (m, n) of
      (Even m, Even n) => Even (m * n)
    | (Even m, Odd n)  => Even (m * n)
    | (Odd m, Even n)  => Even (m * n)
    | (Odd m, Odd n)   => Odd  (m * n)

val five = Odd 5
val six = Even 6

val five_times_five = mult five five
val five_times_six = mult five six
