class Even
  attr_accessor :n

  def initialize(n)
    if n.odd?
      raise "Even#new with non-even `n`"
    end
    self.n = n
  end

  def mult(other)
    other.mult_even(self)
  end

  def mult_even(other)
    Even.new(n * other.n)
  end
  def mult_odd(other)
    Even.new(n * other.n)
  end
end

class Odd
  attr_accessor :n

  def initialize(n)
    if n.even?
      raise "Odd#new with non-odd `n`"
    end
    self.n = n
  end

  def mult(other)
    other.mult_odd(self)
  end

  def mult_even(other)
    Even.new(n * other.n)
  end
  def mult_odd(other)
    Odd.new(n * other.n)
  end
end

five = Odd.new 5
six = Even.new 6

puts "5 * 5 => #{five.mult(five).inspect}"
puts "5 * 6 => #{five.mult(six).inspect}"
